// Generated by CoffeeScript 1.3.1
(function() {
  var cache, combine, deduce, deduceColumns, deduceRows, filter, initialise, inputs, isComplete, parse, possibilities, prettyPrint, puzzle, solution, solve, solvePuzzle, str, sum, _;

  _ = require('lodash');

  parse = function(str) {
    var blocks, cols, dims, i, info, infos, puzzle, rows, _ref, _ref1;
    _ref = str.split(':'), dims = _ref[0], info = _ref[1];
    _ref1 = dims.split('x'), cols = _ref1[0], rows = _ref1[1];
    infos = info.split('/');
    infos = _.map(infos, function(info) {
      return _.map(info.split('.'), function(s) {
        return parseInt(s, 10);
      });
    });
    puzzle = {
      rows: rows,
      columns: cols,
      columnInfo: (function() {
        var _i, _len, _ref2, _results;
        _ref2 = infos.slice(0, cols);
        _results = [];
        for (i = _i = 0, _len = _ref2.length; _i < _len; i = ++_i) {
          blocks = _ref2[i];
          _results.push({
            index: i,
            blocks: blocks
          });
        }
        return _results;
      })(),
      rowInfo: (function() {
        var _i, _len, _ref2, _results;
        _ref2 = infos.slice(cols, rows + cols);
        _results = [];
        for (i = _i = 0, _len = _ref2.length; _i < _len; i = ++_i) {
          blocks = _ref2[i];
          _results.push({
            index: i,
            blocks: blocks
          });
        }
        return _results;
      })()
    };
    return puzzle;
  };

  sum = function(arr) {
    return _.reduce(arr, (function(m, b) {
      return m + b;
    }), 0);
  };

  prettyPrint = function(grid) {
    var c, e, result, row, _i, _j, _len, _len1;
    result = "";
    for (_i = 0, _len = grid.length; _i < _len; _i++) {
      row = grid[_i];
      for (_j = 0, _len1 = row.length; _j < _len1; _j++) {
        e = row[_j];
        if (e === 1) {
          c = 'B';
        }
        if (e === -1) {
          c = 'W';
        }
        if (e === 0) {
          c = '?';
        }
        result += c;
      }
      result += '\n';
    }
    return result.slice(0, result.length - 1);
  };

  combine = function(arrs) {
    var arr, newArrs, result, _i, _len;
    result = [];
    newArrs = _.zip.apply(_, arrs);
    for (_i = 0, _len = newArrs.length; _i < _len; _i++) {
      arr = newArrs[_i];
      if (_.all(arr, function(a) {
        return a === 1;
      })) {
        result.push(1);
      } else if (_.all(arr, function(a) {
        return a === -1;
      })) {
        result.push(-1);
      } else {
        result.push(0);
      }
    }
    return result;
  };

  filter = function(poss, template) {
    return _.filter(poss, function(arr) {
      var zs;
      zs = _.zip(arr, template);
      return _.all(zs, function(z) {
        if (z[0] !== -z[1]) {
          return true;
        } else {
          return false;
        }
      });
    });
  };

  cache = {};

  possibilities = function(blocks, size) {
    var i, j, key, newResult, newResults, newSize, prelude, restLength, result, _i, _j, _k, _l, _len, _m, _ref, _ref1, _ref2;
    key = "" + (JSON.stringify(blocks)) + ":::" + size;
    if (cache[key] != null) {
      return cache[key];
    }
    if (blocks.length === 0) {
      result = [[]];
      for (i = _i = 1; _i <= size; i = _i += 1) {
        result[0].push(-1);
      }
      return result;
    }
    if (blocks[0] === 0) {
      return possibilities(blocks.slice(1), size);
    }
    if (blocks.length === 1) {
      restLength = 0;
    } else {
      restLength = -2 + blocks.length + (sum(blocks.slice(1)));
    }
    result = [];
    for (i = _j = 0, _ref = size - restLength - blocks[0]; _j <= _ref; i = _j += 1) {
      prelude = [];
      for (j = _k = 0, _ref1 = i - 1; _k <= _ref1; j = _k += 1) {
        prelude.push(-1);
      }
      for (j = _l = 1, _ref2 = blocks[0]; 1 <= _ref2 ? _l <= _ref2 : _l >= _ref2; j = 1 <= _ref2 ? ++_l : --_l) {
        prelude.push(1);
      }
      if (restLength > 0) {
        prelude.push(-1);
      }
      newSize = size - prelude.length;
      newResults = possibilities(blocks.slice(1), newSize);
      for (_m = 0, _len = newResults.length; _m < _len; _m++) {
        newResult = newResults[_m];
        result.push(prelude.concat(newResult));
      }
    }
    cache[key] = result;
    return result;
  };

  initialise = function(rows, cols) {
    var grid, i, j, row, _i, _j;
    grid = [];
    row = [];
    for (i = _i = 1; 1 <= cols ? _i <= cols : _i >= cols; i = 1 <= cols ? ++_i : --_i) {
      row.push(0);
    }
    for (j = _j = 1; 1 <= rows ? _j <= rows : _j >= rows; j = 1 <= rows ? ++_j : --_j) {
      grid.push(row.slice());
    }
    return grid;
  };

  deduceRows = function(grid, rowInfo, size, affectedRows) {
    var aff, affectedColumns, blocks, gRow, i, info, last, n, newRow, o, poss, poss2, row, _i, _len;
    affectedColumns = [];
    last = JSON.stringify(grid);
    for (_i = 0, _len = affectedRows.length; _i < _len; _i++) {
      i = affectedRows[_i];
      info = rowInfo[i];
      blocks = info.blocks;
      row = info.index;
      poss = possibilities(blocks, size);
      gRow = grid[row];
      poss2 = filter(poss, gRow);
      newRow = combine(poss2);
      aff = (function() {
        var _j, _len1, _ref, _ref1, _results;
        _ref = _.zip(gRow, newRow);
        _results = [];
        for (i = _j = 0, _len1 = _ref.length; _j < _len1; i = ++_j) {
          _ref1 = _ref[i], o = _ref1[0], n = _ref1[1];
          if (o !== n) {
            _results.push(i);
          }
        }
        return _results;
      })();
      affectedColumns = affectedColumns.concat(aff);
      grid[row] = newRow;
    }
    affectedColumns = _.uniq(affectedColumns);
    return [grid, affectedColumns];
  };

  deduceColumns = function(grid, columnInfo, size, affectedColumns) {
    var affectedRows, flippedGrid, unflippedGrid, _ref;
    flippedGrid = _.zip.apply(_, grid);
    _ref = deduceRows(flippedGrid, columnInfo, size, affectedColumns), flippedGrid = _ref[0], affectedRows = _ref[1];
    unflippedGrid = _.zip.apply(_, flippedGrid);
    return [unflippedGrid, affectedRows];
  };

  deduce = function(grid, puzzle) {
    var affectedColumns, affectedRows, last, xxx, _i, _j, _ref, _ref1, _ref2, _ref3, _ref4, _results, _results1;
    last = null;
    affectedRows = (function() {
      _results = [];
      for (var _i = 0, _ref = puzzle.rows - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; 0 <= _ref ? _i++ : _i--){ _results.push(_i); }
      return _results;
    }).apply(this);
    affectedColumns = (function() {
      _results1 = [];
      for (var _j = 0, _ref1 = puzzle.columns - 1; 0 <= _ref1 ? _j <= _ref1 : _j >= _ref1; 0 <= _ref1 ? _j++ : _j--){ _results1.push(_j); }
      return _results1;
    }).apply(this);
    _ref2 = deduceColumns(grid, puzzle.columnInfo, puzzle.rows, affectedColumns), grid = _ref2[0], xxx = _ref2[1];
    while (last !== JSON.stringify(grid)) {
      last = JSON.stringify(grid);
      _ref3 = deduceRows(grid, puzzle.rowInfo, puzzle.columns, affectedRows), grid = _ref3[0], affectedColumns = _ref3[1];
      if (affectedColumns.length === 0) {
        break;
      }
      _ref4 = deduceColumns(grid, puzzle.columnInfo, puzzle.rows, affectedColumns), grid = _ref4[0], affectedRows = _ref4[1];
      if (affectedRows.length === 0) {
        break;
      }
    }
    return grid;
  };

  isComplete = function(grid) {
    return _.all(_.flatten(grid), function(e) {
      return e !== 0;
    });
  };

  solvePuzzle = function(puzzle) {
    var grid;
    grid = initialise(puzzle.rows, puzzle.columns);
    return solve(grid, puzzle);
  };

  solve = function(grid, puzzle) {
    var blocks, finalGrid, gRow, hmm, info, p, poss, poss2, row, storedGrid, testGrid, _i, _j, _k, _l, _len, _len1, _len2, _len3, _ref, _ref1;
    grid = deduce(grid, puzzle);
    if (!isComplete(grid)) {
      storedGrid = JSON.stringify(grid);
      _ref = puzzle.rowInfo;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        info = _ref[_i];
        blocks = info.blocks;
        row = info.index;
        poss = possibilities(blocks, puzzle.columns);
        gRow = grid[row];
        poss2 = filter(poss, gRow);
        hmm = combine(poss2);
        if ((JSON.stringify(hmm)) === (JSON.stringify(gRow)) && (_.any(hmm, function(h) {
          return h === 0;
        }))) {
          for (_j = 0, _len1 = poss2.length; _j < _len1; _j++) {
            p = poss2[_j];
            testGrid = JSON.parse(storedGrid);
            testGrid[row] = p;
            finalGrid = solve(testGrid, puzzle);
            if (isComplete(finalGrid)) {
              return finalGrid;
            }
          }
        }
      }
      grid = _.zip.apply(_, grid);
      _ref1 = puzzle.columnInfo;
      for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
        info = _ref1[_k];
        blocks = info.blocks;
        row = info.index;
        poss = possibilities(blocks, puzzle.rows);
        gRow = grid[row];
        poss2 = filter(poss, gRow);
        hmm = combine(poss2);
        if ((JSON.stringify(hmm)) === (JSON.stringify(gRow)) && (_.any(hmm, function(h) {
          return h === 0;
        }))) {
          for (_l = 0, _len3 = poss2.length; _l < _len3; _l++) {
            p = poss2[_l];
            testGrid = _.zip.apply(_, JSON.parse(storedGrid));
            testGrid[row] = p;
            finalGrid = solve(_.zip.apply(_, testGrid), puzzle);
            if (isComplete(finalGrid)) {
              return finalGrid;
            }
          }
        }
        ++row;
      }
    }
    return grid;
  };

  inputs = process.argv.slice(2);

  str = inputs[0];

  puzzle = parse(str);

  solution = solvePuzzle(puzzle);

  console.log(prettyPrint(solution));

}).call(this);
